<template>
	<div v-if="activeUpsell && !isActiveUpsellFulfilled" :class="$style.upsell">
		<div :class="$style.introWrapper">
			<button :class="$style.introText" @click="isOpen = !isOpen">
				<span>{{ introText }}</span>
				<span :class="$style.underline" />
			</button>
		</div>
		<AtomTransitionExpand>
			<div v-if="isOpen" :class="$style.wrapper">
				<div :class="$style.arrowOuterWrapper">
					<span :class="$style.arrowInnerWrapper"><span :class="$style.arrow" /></span>
				</div>
				<div :class="$style.missingProductContainerWrapper">
					<div :class="$style.missingProductContainer">
						<div :class="$style.headingAndClose">
							<h3 :class="$style.heading">What a pair: {{ missingProduct.name }}</h3>
							<button :class="$style.close" aria-label="Close" @click="isOpen = !isOpen">
								<BaseIcon name="cross" width="16" height="16" title="Close" />
							</button>
						</div>

						<div :class="$style.missingProductContent">
							<div :class="$style.imageWrapper">
								<BaseImage :image="missingProduct.image" :aspect="1" contain sizes="76px" alt="" />
							</div>
							<div :class="$style.infoWrapper">
								<div :class="$style.message">{{ missingProduct.message }}</div>
								<BaseButton
									:class="$style.cta"
									:smart="`/add-to-cart?skus=${missingProduct.sku}`"
									size="medium"
									add-to-cart-source="sidecart"
								/>
							</div>
						</div>
					</div>
				</div>
			</div>
		</AtomTransitionExpand>
		<AtomTransitionExpand>
			<div v-if="!isOpen">
				<div :class="$style.extraPadding" />
			</div>
		</AtomTransitionExpand>
	</div>
</template>

<script>
import AtomTransitionExpand from '@components/atom-transition-expand';
import { mapState, mapGetters } from 'vuex';

export default {
	components: { AtomTransitionExpand },

	props: {
		cartItems: {
			type: Array,
			required: true,
		},

		cartDiscount: {
			type: Number,
			required: true,
		},
	},

	data: () => ({ isOpen: false }),

	computed: {
		...mapGetters('magento', ['cart']),
		...mapGetters(['currencySymbol']),
		...mapState('magento', ['upsells', 'products']),

		activeUpsell() {
			const { upsells, cartItems } = this;
			const upsellsWithMultipleProducts = upsells.filter((upsell) => upsell.items.length > 1);
			let activeUpsell;

			for (let i = 0; i < upsellsWithMultipleProducts.length; i++) {
				const upsell = upsellsWithMultipleProducts[i];

				const areCartItemsInUpsell = cartItems.every((cartItem, i) => {
					if (i === 0) {
						const firstUpsellItem = upsell.items[0];
						return firstUpsellItem.sku === cartItem.sku && firstUpsellItem.qty >= cartItem.qty;
					}

					return upsell.items.some((upsellItem) => upsellItem.sku === cartItem.sku && upsellItem.qty >= cartItem.qty);
				});

				if (areCartItemsInUpsell) {
					activeUpsell = {
						...upsell,
						discount: Math.ceil(Math.abs(upsell.discount)),
					};
					break;
				} else {
					continue;
				}
			}

			return activeUpsell;
		},

		isActiveUpsellFulfilled() {
			const { activeUpsell } = this;
			if (!activeUpsell) return;

			const { cartItems } = this;
			return (
				cartItems.length === activeUpsell.items.length &&
				activeUpsell.items.every((upsellItem) =>
					cartItems.some((cartItem) => cartItem.sku === upsellItem.sku && cartItem.qty === upsellItem.qty)
				)
			);
		},

		missingProduct() {
			const { activeUpsell } = this;

			if (!activeUpsell || this.isActiveUpsellFulfilled) return null;

			const { cartItems, products, currencySymbol } = this;

			const missingProducts = activeUpsell.items.reduce((missingProducts, item) => {
				const { sku, qty, name } = item;
				const foundCartItem = cartItems.find((cartItem) => cartItem.sku === sku);
				const updatedQty = qty - (foundCartItem ? foundCartItem.qty : 0);

				if (!foundCartItem || foundCartItem.qty < qty) {
					missingProducts[sku] = {
						...products[sku],
						message: `You’re ${updatedQty} ${name} from saving ${currencySymbol}${activeUpsell.discount}`,
						qty: updatedQty,
					};
				}

				return missingProducts;
			}, {});

			return missingProducts[Object.keys(missingProducts)[0]];
		},

		introText() {
			const { activeUpsell } = this;
			if (!activeUpsell || this.isActiveUpsellFulfilled) return '';

			const { isOpen, currencySymbol } = this;

			return `${isOpen ? `Now that’s fresh` : `Get the bundle`}. Save ${currencySymbol}${activeUpsell.discount}`;
		},
	},

	watch: {
		isActiveUpsellFulfilled(val) {
			if (val) this.isOpen = false;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.upsell {
	margin: 0 0 -1.6rem;
}

.introWrapper {
	padding: 3.1rem 0 0;
}

.introText {
	@include use-text-style('type-200');

	display: flex;
	flex-direction: column;
	margin: auto;
}

.underline {
	display: block;
	width: 100%;
	height: 1px;
	margin: 0.6em 0 0;
	background: #00f;
}

.defaultText {
	@include use-text-style('heading-200');

	margin: 1.1rem 0;
}

.wrapper {
	margin: 0 -2rem;

	@include above('medium') {
		margin: 0 -3.6rem;
	}
}

.missingProductContainerWrapper {
	padding: 0 1.9rem;
	background: color('primary-600');

	@include above('medium') {
		padding: 0 3.8rem;
	}
}

.missingProductContainer {
	position: relative;
	z-index: 1;
	padding: 1.8rem 0 2rem;
	// margin: 0 0 -1.5rem;

	@include above('medium') {
		padding: 3.6rem 0 4rem;
	}
}

.arrowOuterWrapper {
	height: 3rem;
}

.arrowInnerWrapper {
	display: flex;
	align-items: center;
	justify-content: center;
}

.arrow {
	position: relative;
	top: 2.7rem;
	z-index: -1;
	display: block;
	width: 100px;
	height: 100px;
	background: color('primary-600');
	transform: rotate(45deg);
}

.headingAndClose {
	display: flex;
	align-items: top;
	justify-content: space-between;
	margin: 0 0 1.2rem;

	@include above('medium') {
		margin: 0 0 3.6rem;
	}
}

.heading {
	@include use-text-style('heading-150');

	font-family: font-family('secondary');
	line-height: 2.2rem;

	@include above('medium') {
		@include use-text-style('heading-200');
	}
}

.close {
	position: relative;
	top: 0;
	width: 1.6rem;
	height: 1.6rem;
}

.missingProductContent {
	display: grid;
	grid-template-columns: 5fr 7fr;
	gap: 2rem;

	@include above('medium') {
		gap: 3.6rem;
	}
}

.imageWrapper {
	flex: 0 1 auto;
	width: 12.7rem;
	height: 12.7rem;
	padding: 1.9rem;
	border-radius: 10px;

	@include above('small') {
		width: 15.4rem;
		height: 15.4rem;
	}
}

.infoWrapper {
	@include use-text-style('type-200');

	display: flex;
	flex-direction: column;
	justify-content: space-between;
	line-height: 1.5;

	@include above('medium') {
		line-height: 1.95;
	}
}

.message {
	padding: 0.5em 0 0;
	font-weight: 300;

	@include above('medium') {
		padding: 0.75em 0 0;
	}
}

.cta {
	border-radius: 3rem !important;
}

.extraPadding {
	height: 5rem;
}
</style>
